# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['EncryptionAtRestArgs', 'EncryptionAtRest']

@pulumi.input_type
class EncryptionAtRestArgs:
    def __init__(__self__, *,
                 project_id: pulumi.Input[str],
                 aws_kms: Optional[pulumi.Input['EncryptionAtRestAwsKmsArgs']] = None,
                 azure_key_vault: Optional[pulumi.Input['EncryptionAtRestAzureKeyVaultArgs']] = None,
                 google_cloud_kms: Optional[pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs']] = None):
        """
        The set of arguments for constructing a EncryptionAtRest resource.
        :param pulumi.Input[str] project_id: The unique identifier for the project.
        :param pulumi.Input['EncryptionAtRestAwsKmsArgs'] aws_kms: Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input['EncryptionAtRestAzureKeyVaultArgs'] azure_key_vault: Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs'] google_cloud_kms: Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        pulumi.set(__self__, "project_id", project_id)
        if aws_kms is not None:
            pulumi.set(__self__, "aws_kms", aws_kms)
        if azure_key_vault is not None:
            pulumi.set(__self__, "azure_key_vault", azure_key_vault)
        if google_cloud_kms is not None:
            pulumi.set(__self__, "google_cloud_kms", google_cloud_kms)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[str]:
        """
        The unique identifier for the project.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="awsKms")
    def aws_kms(self) -> Optional[pulumi.Input['EncryptionAtRestAwsKmsArgs']]:
        """
        Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "aws_kms")

    @aws_kms.setter
    def aws_kms(self, value: Optional[pulumi.Input['EncryptionAtRestAwsKmsArgs']]):
        pulumi.set(self, "aws_kms", value)

    @property
    @pulumi.getter(name="azureKeyVault")
    def azure_key_vault(self) -> Optional[pulumi.Input['EncryptionAtRestAzureKeyVaultArgs']]:
        """
        Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "azure_key_vault")

    @azure_key_vault.setter
    def azure_key_vault(self, value: Optional[pulumi.Input['EncryptionAtRestAzureKeyVaultArgs']]):
        pulumi.set(self, "azure_key_vault", value)

    @property
    @pulumi.getter(name="googleCloudKms")
    def google_cloud_kms(self) -> Optional[pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs']]:
        """
        Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "google_cloud_kms")

    @google_cloud_kms.setter
    def google_cloud_kms(self, value: Optional[pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs']]):
        pulumi.set(self, "google_cloud_kms", value)


@pulumi.input_type
class _EncryptionAtRestState:
    def __init__(__self__, *,
                 aws_kms: Optional[pulumi.Input['EncryptionAtRestAwsKmsArgs']] = None,
                 azure_key_vault: Optional[pulumi.Input['EncryptionAtRestAzureKeyVaultArgs']] = None,
                 google_cloud_kms: Optional[pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs']] = None,
                 project_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering EncryptionAtRest resources.
        :param pulumi.Input['EncryptionAtRestAwsKmsArgs'] aws_kms: Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input['EncryptionAtRestAzureKeyVaultArgs'] azure_key_vault: Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs'] google_cloud_kms: Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[str] project_id: The unique identifier for the project.
        """
        if aws_kms is not None:
            pulumi.set(__self__, "aws_kms", aws_kms)
        if azure_key_vault is not None:
            pulumi.set(__self__, "azure_key_vault", azure_key_vault)
        if google_cloud_kms is not None:
            pulumi.set(__self__, "google_cloud_kms", google_cloud_kms)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)

    @property
    @pulumi.getter(name="awsKms")
    def aws_kms(self) -> Optional[pulumi.Input['EncryptionAtRestAwsKmsArgs']]:
        """
        Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "aws_kms")

    @aws_kms.setter
    def aws_kms(self, value: Optional[pulumi.Input['EncryptionAtRestAwsKmsArgs']]):
        pulumi.set(self, "aws_kms", value)

    @property
    @pulumi.getter(name="azureKeyVault")
    def azure_key_vault(self) -> Optional[pulumi.Input['EncryptionAtRestAzureKeyVaultArgs']]:
        """
        Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "azure_key_vault")

    @azure_key_vault.setter
    def azure_key_vault(self, value: Optional[pulumi.Input['EncryptionAtRestAzureKeyVaultArgs']]):
        pulumi.set(self, "azure_key_vault", value)

    @property
    @pulumi.getter(name="googleCloudKms")
    def google_cloud_kms(self) -> Optional[pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs']]:
        """
        Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "google_cloud_kms")

    @google_cloud_kms.setter
    def google_cloud_kms(self, value: Optional[pulumi.Input['EncryptionAtRestGoogleCloudKmsArgs']]):
        pulumi.set(self, "google_cloud_kms", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[str]]:
        """
        The unique identifier for the project.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_id", value)


class EncryptionAtRest(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aws_kms: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestAwsKmsArgs']]] = None,
                 azure_key_vault: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestAzureKeyVaultArgs']]] = None,
                 google_cloud_kms: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestGoogleCloudKmsArgs']]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a EncryptionAtRest resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['EncryptionAtRestAwsKmsArgs']] aws_kms: Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[pulumi.InputType['EncryptionAtRestAzureKeyVaultArgs']] azure_key_vault: Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[pulumi.InputType['EncryptionAtRestGoogleCloudKmsArgs']] google_cloud_kms: Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[str] project_id: The unique identifier for the project.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: EncryptionAtRestArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a EncryptionAtRest resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param EncryptionAtRestArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(EncryptionAtRestArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aws_kms: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestAwsKmsArgs']]] = None,
                 azure_key_vault: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestAzureKeyVaultArgs']]] = None,
                 google_cloud_kms: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestGoogleCloudKmsArgs']]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = EncryptionAtRestArgs.__new__(EncryptionAtRestArgs)

            __props__.__dict__["aws_kms"] = aws_kms
            __props__.__dict__["azure_key_vault"] = azure_key_vault
            __props__.__dict__["google_cloud_kms"] = google_cloud_kms
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
        super(EncryptionAtRest, __self__).__init__(
            'mongodbatlas:index/encryptionAtRest:EncryptionAtRest',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            aws_kms: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestAwsKmsArgs']]] = None,
            azure_key_vault: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestAzureKeyVaultArgs']]] = None,
            google_cloud_kms: Optional[pulumi.Input[pulumi.InputType['EncryptionAtRestGoogleCloudKmsArgs']]] = None,
            project_id: Optional[pulumi.Input[str]] = None) -> 'EncryptionAtRest':
        """
        Get an existing EncryptionAtRest resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['EncryptionAtRestAwsKmsArgs']] aws_kms: Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[pulumi.InputType['EncryptionAtRestAzureKeyVaultArgs']] azure_key_vault: Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[pulumi.InputType['EncryptionAtRestGoogleCloudKmsArgs']] google_cloud_kms: Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        :param pulumi.Input[str] project_id: The unique identifier for the project.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _EncryptionAtRestState.__new__(_EncryptionAtRestState)

        __props__.__dict__["aws_kms"] = aws_kms
        __props__.__dict__["azure_key_vault"] = azure_key_vault
        __props__.__dict__["google_cloud_kms"] = google_cloud_kms
        __props__.__dict__["project_id"] = project_id
        return EncryptionAtRest(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="awsKms")
    def aws_kms(self) -> pulumi.Output[Optional['outputs.EncryptionAtRestAwsKms']]:
        """
        Specifies AWS KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "aws_kms")

    @property
    @pulumi.getter(name="azureKeyVault")
    def azure_key_vault(self) -> pulumi.Output[Optional['outputs.EncryptionAtRestAzureKeyVault']]:
        """
        Specifies Azure Key Vault configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "azure_key_vault")

    @property
    @pulumi.getter(name="googleCloudKms")
    def google_cloud_kms(self) -> pulumi.Output[Optional['outputs.EncryptionAtRestGoogleCloudKms']]:
        """
        Specifies GCP KMS configuration details and whether Encryption at Rest is enabled for an Atlas project.
        """
        return pulumi.get(self, "google_cloud_kms")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[str]:
        """
        The unique identifier for the project.
        """
        return pulumi.get(self, "project_id")

